/*
 * 消息黑名单
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.BsModels;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class MsgBlackListController : BaseController
    {
        public MsgBlackListController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["BsSqlConnStr"].ToString();
        }

        #region 消息黑名单列表

        /// <summary>
        /// 根据条件查询消息黑名单列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(MsgBlackList data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            string Condition = "";
            Condition += "ColId:\"" + data.ColId + "\",";
Condition += "TemplateId:\"" + data.TemplateId + "\",";
Condition += "Mobile:\"" + data.Mobile + "\",";
Condition += "Ip:\"" + data.Ip + "\",";

            if (!string.IsNullOrEmpty(Condition))
            { 
                Condition = Condition.TrimEnd(',');
                Condition = ", where: {" + Condition + "}";
            }
            ViewBag.Condition = Condition;
            return View();
        }

        #endregion

        #region 根据条件查询消息黑名单列表

        /// <summary>
        /// 消息黑名单列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(MsgBlackList data, int page = 1, int limit = 30)
        {
            
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            
            Fields.Add("ColId", "1"); //分类
Fields.Add("CreateDate", "3"); //时间
Fields.Add("TemplateId", "1"); //模板
Fields.Add("Mobile", "2"); //手机号
Fields.Add("Ip", "2"); //IP地址

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgBlackList", Fields, "Id desc", "0", page, limit, " and Status>-1");
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ColId"] = RelationClass.GetColInfo(dic["ColId"].ToString());
dic["TemplateId"] = RelationClass.GetMsgTemplateInfo(int.Parse(dic["TemplateId"].ToString()));

            }
            return Json(obj);
        }

        #endregion

        #region 增加消息黑名单

        /// <summary>
        /// 增加或修改消息黑名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            return View();
        }

        #endregion

        #region 增加消息黑名单

        /// <summary>
        /// 增加或修改消息黑名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(MsgBlackList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ColId", data.ColId); //分类
Fields.Add("TemplateId", data.TemplateId); //模板
Fields.Add("Mobile", data.Mobile); //手机号
Fields.Add("Ip", data.Ip); //IP地址
Fields.Add("Reason", data.Reason); //加入黑名单原因

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Add("MsgBlackList", Fields, 0);
            AddSysLog(data.Id.ToString(), "MsgBlackList", "add");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 修改消息黑名单

        /// <summary>
        /// 增加或修改消息黑名单信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;
            

            MsgBlackList editData = bsdb.MsgBlackList.FirstOrDefault(m => m.Id == Id) ?? new MsgBlackList();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改消息黑名单

        /// <summary>
        /// 增加或修改消息黑名单信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(MsgBlackList data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();
            
            Fields.Add("ColId", data.ColId); //分类
Fields.Add("TemplateId", data.TemplateId); //模板
Fields.Add("Mobile", data.Mobile); //手机号
Fields.Add("Ip", data.Ip); //IP地址
Fields.Add("Reason", data.Reason); //加入黑名单原因

            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgBlackList", Fields, data.Id);
            AddSysLog(data.Id.ToString(),"MsgBlackList","update");
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 删除消息黑名单信息

        /// <summary>
        /// 删除消息黑名单信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgBlackList","del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgBlackList", Fields, id);
            }
            bsdb.SaveChanges();
            
            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgBlackList","open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgBlackList", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id,"MsgBlackList","close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Edit("MsgBlackList", Fields, id);
            }
            bsdb.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).Sort("MsgBlackList", Sort, Id);
            
            AddSysLog(Id.ToString(), "MsgBlackList", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count;i++ )
            {
                JsonData dr = list[i];
                
                bsdb.MsgBlackList.Add(new MsgBlackList()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,
                    
                });
                bsdb.SaveChanges();
            }
            AddSysLog("0", "MsgBlackList", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(MsgBlackList data)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("ColId", "1"); //分类
Fields.Add("CreateDate", "3"); //时间
Fields.Add("TemplateId", "1"); //模板
Fields.Add("Mobile", "2"); //手机号
Fields.Add("Ip", "2"); //IP地址

            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.BsTables).IndexData("MsgBlackList", Fields, "Id desc", "0", 1, 20000, "", "Remark", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                dic["ColId"] = RelationClass.GetColInfo(dic["ColId"].ToString());
dic["TemplateId"] = RelationClass.GetMsgTemplateInfo(int.Parse(dic["TemplateId"].ToString()));

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("Remark", "注释");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "MsgBlackList", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
